Bug 63184

Summary: SSI documentation is incomplete
Product: Tomcat 9 Reporter: research
Component: DocumentationAssignee: Tomcat Developers Mailing List <dev>
Status: RESOLVED FIXED    
Severity: enhancement    
Priority: P2    
Version: 9.0.16   
Target Milestone: -----   
Hardware: Macintosh   
OS: All   

Description research 2019-02-17 19:28:36 UTC
Re:
https://tomcat.apache.org/tomcat-9.0-doc/ssi-howto.html


The SSI documentation can be improved in several ways:
- It doesn't mention that SSI variables (set/echo) are actually request attributes  and thus are not scope of SSI only. That means SSI pages can see attributes set by other components, and can set request attributes to pass to other components
- The "config" directive takes three parameters but they are not mentioned - "errmsg", "sizefmt" and "timefmt"
- The "echo" directive has an encoding parameter that appears in code but is not mentioned in the documentation. It can be "url", "entity" or "none"; defaulting to "entity"
- The "exec" directive take a "cmd" or "cgi" parameters - the "cgi" parameter, when used is the same as include
- The "include", "flastmod" and "fsize" directives can take either "file" or "virtual" parameters but they are not both documented
- SSI variables cannot start with "java.", "javax." or "sun." but this is not mentioned
Comment 1 research 2019-02-17 19:32:21 UTC
Another reserved namespace is "org.apache.catalina.ssi.SSIMediator.*"
Comment 2 Christopher Schultz 2019-02-18 19:45:59 UTC
Patches are always welcome, including documentation patches.
Comment 3 research 2019-02-19 02:39:21 UTC
Pull request here:
https://github.com/apache/tomcat/pull/138
Comment 4 Mark Thomas 2019-03-15 11:18:30 UTC
Fixed in:
- master for 9.0.18 onwards
- 8.5.x for 8.5.40 onwards
- 7.0.x for 7.0.94 onwards